from src.batch.ultmarc.utmp_tables.table_mapper.ultmarc_table_mapper import \
    UltmarcTableMapper
from src.batch.ultmarc.utmp_tables.tables.com_post import ComPost


class ComPostMapper(UltmarcTableMapper):
    """レイアウト区分005: COM_役職 登録処理"""

    # レコード存在確認SQL
    RECORD_EXISTS_QUERY = """\
    SELECT
        COUNT(*) AS count_num
    FROM
        src05.com_post
    WHERE
        post_cd = :post_cd
    """
    # データ登録用SQL
    INSERT_QUERY = """\
    INSERT INTO src05.com_post
    (
        post_cd,
        form_post_name,
        regist_ymd,
        sys_regist_date,
        regist_prgm_id,
        sys_update_date,
        update_prgm_id
    )
    VALUES (
        :post_cd,
        :form_post_name,
        :execute_date_str_ymd,
        :execute_datetime,
        :program_name,
        :execute_datetime,
        :program_name
    )
    """

    UPDATE_QUERY = """\
    UPDATE
        src05.com_post
    SET
        form_post_name = :form_post_name,
        update_ymd = :execute_date_str_ymd,
        sys_update_date = :execute_datetime,
        update_prgm_id = :program_name
    WHERE
        post_cd = :post_cd
    """

    # 修正区分が「C(削除)」の場合の更新SQL
    LOGICAL_DELETE_QUERY = """\
    UPDATE
        src05.com_post
    SET
        delete_ymd = :execute_date_str_ymd,
        sys_update_date = :execute_date_str_ymd,
        update_prgm_id = :program_name
    WHERE
        post_cd = :post_cd
    """
    record: ComPost

    def __init__(self, record: list[str], db) -> None:
        super().__init__(record, db, ComPost)
        program_name = __name__.split('.')[-1]  # 当モジュール名(現行から変わっている)
        # モジュール名をクエリパラメータに設定
        self.query_parameter['program_name'] = program_name
        # 読み込んだレコード値もクエリパラメータに追加
        self.query_parameter = {**self.query_parameter, **self.record.to_sql_parameter()}

    def make_query(self):
        # 修正区分がC(削除)の場合、論理削除
        if self.record.maint_flag == 'C':
            self.queries.append(self.LOGICAL_DELETE_QUERY)
            return

        # 追加、更新の場合
        self.queries.append(self.__make_upsert_query())
        return

    def __make_upsert_query(self):
        # レコードの存在確認
        record_count = self.db.execute_select(self.RECORD_EXISTS_QUERY, self.query_parameter)
        # 存在しない場合はInsert
        if record_count[0]['count_num'] == 0:
            return self.INSERT_QUERY

        # 存在する場合ではUpdate
        return self.UPDATE_QUERY
